package com.loafle.overflow.central.module.apikey.service;

import com.loafle.overflow.central.module.apikey.dao.ApiKeyDAO;

import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.apikey.ApiKey;
import com.loafle.overflow.service.central.apikey.ApiKeyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("ApiKeyService")
public class CentralApiKeyService implements ApiKeyService {

  @Autowired
  private ApiKeyDAO apiKeyDAO;

  public ApiKey regist(ApiKey apiKey) throws OverflowException {

    return this.apiKeyDAO.save(apiKey);
  }

  public ApiKey readByDomainID(Long domainID) throws OverflowException {
    return this.apiKeyDAO.findByDomainId(domainID);
  }

  public boolean check(String apiKey) throws OverflowException {

    ApiKey retApiKey = this.apiKeyDAO.findByApiKey(apiKey);

    if (retApiKey == null) {
      return false;
    }

    return true;
  }

  public ApiKey readByApiKey(String apiKey) throws OverflowException {
    return this.apiKeyDAO.findByApiKey(apiKey);
  }

}
