package com.loafle.overflow.central.module.generator.service;

import com.loafle.overflow.model.meta.MetaSensorItemKey;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.sensor.SensorItem;
import com.loafle.overflow.model.sensorconfig.Item;
import com.loafle.overflow.model.sensorconfig.Keys;
import com.loafle.overflow.model.sensorconfig.MappingInfo;
import com.loafle.overflow.model.sensorconfig.QueryInfo;
import com.loafle.overflow.model.sensorconfig.SensorConfig;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.core.type.TypeReference;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by geek on 17. 9. 11.
 */
@Service("InfraServiceJMXGenerator")
public class InfraServiceJMXGenerator {

  @Autowired
  private GenerateUtil generateUtil;

  @Autowired
  private ObjectMapper objectMapper;

  public void process(List<SensorItem> sensorItems, Map<Integer, MetaSensorItemKey> keyMap, Sensor dbSensor,
      SensorConfig sensorConfig) throws Exception {
    Map<String, List<MetaSensorItemKey>> metricMap = null;
    metricMap = this.generateUtil.sortItems(sensorItems, keyMap);

    List<Item> itemList = new ArrayList<>();
    Item item = null;
    QueryInfo queryInfo = null;
    MappingInfo mappingInfo = null;

    StringBuffer buffer = new StringBuffer();

    Map<String, Object> extendMap = new HashMap<>();

    List<Keys> keysList = null;
    MetaSensorItemKey tempItemKey = null;
    Keys keys = null;

    for (Map.Entry<String, List<MetaSensorItemKey>> elms : metricMap.entrySet()) {
      keysList = new ArrayList<>();
      item = new Item();
      buffer.setLength(0);

      buffer.append(elms.getKey());

      for (int idx = 0; idx < elms.getValue().size(); idx++) {
        tempItemKey = elms.getValue().get(idx);

        buffer.append(tempItemKey.getKey());

        keys = new Keys();
        keys.setKey(tempItemKey.getKey());
        keys.setMetric(tempItemKey.getMetaSensorItem().getKey());

        keysList.add(this.generateUtil.createKeys(tempItemKey));
      }

      String json = tempItemKey.getOption();
      List<String> aliases = null;
      List<String> arrayCol = null;

      if (json != null && json.length() > 0) {
        HashMap<String, String> optionMap = this.objectMapper.readValue(json, new TypeReference<Map<String, String>>() {
        });

        Object obj = null;
        obj = optionMap.get("aliases");

        if (obj != null) {
          aliases = (List<String>) obj;
        }

        obj = optionMap.get("arrayColumns");
        if (obj != null) {
          arrayCol = (List<String>) obj;
        }
      }

      queryInfo = new QueryInfo();
      queryInfo.setQuery(tempItemKey.getFroms());
      queryInfo.setExtend(extendMap);

      extendMap.put("aliases", aliases);
      mappingInfo = new MappingInfo();
      mappingInfo.setArrayColumns(arrayCol);

      item.setMappingInfo(mappingInfo);
      item.setQueryInfo(queryInfo);
      item.setKeys(keysList);
      itemList.add(item);
    }
    sensorConfig.setItems(itemList);
  }

}
