package com.loafle.overflow.central.module.infra.dao;

import static org.junit.Assert.assertNotNull;

import java.util.List;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.infra.InfraHostPort;
import com.loafle.overflow.model.member.Member;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 9. 14.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { AppConfigTest.class })
public class InfraHostPortDAOTest {

  @Autowired
  private InfraHostPortDAO infraHostPortDAO;

  @Test
  public void findAllByInfraHostIPId() throws Exception {

    List<InfraHostPort> infraHostPorts = this.infraHostPortDAO.findAllByInfraHostIPId((long) 1);

    assertNotNull(infraHostPorts);
  }

  @Test
  public void findAllByInfraHostIPIdAndMetaPortTypeKey() throws Exception {

    List<InfraHostPort> infraHostPorts = this.infraHostPortDAO.findAllByInfraHostIPIdAndMetaPortTypeKey((long) 1,
        "TCP");

    assertNotNull(infraHostPorts);
  }

  @Test
  public void findByInfraHostIPIdAndMetaPortTypeKeyAndPort() throws Exception {

    InfraHostPort infraHostPort = this.infraHostPortDAO.findByInfraHostIPIdAndMetaPortTypeKeyAndPort((long) 1, "TCP",
        5432);

    assertNotNull(infraHostPort);
  }
}
